## lcov 1.3

=== Makefile ===
#
# Makefile for the LTP GCOV extension (LCOV)
#
# Make targets:
#   - install:   install LCOV tools and man pages on the system
#   - uninstall: remove tools and man pages from the system
#   - dist:      create files required for distribution, i.e. the lcov.tar.gz
#                and the lcov.rpm file. Just make sure to adjust the VERSION
#                and RELEASE variables below - both version and date strings
#                will be updated in all necessary files.
#   - clean:     remove all generated files
#

VERSION := 1.3
RELEASE := 1
DATE    := $(shell date +%Y-%m-%d)

BIN_DIR := $(PREFIX)/usr/bin
MAN_DIR := $(PREFIX)/usr/share/man
TMP_DIR := /tmp/lcov-tmp.$(shell echo $$$$)
FILES   := $(wildcard bin/*) $(wildcard man/*) README CHANGES Makefile \
	   $(wildcard rpm/*)

.PHONY: all info clean install uninstall rpms

all: info

info:
	@echo try "'make install'", "'make uninstall'" or "'make dist'"

clean:
	rm -f lcov-*.tar.gz
	rm -f lcov-*.rpm
	make -C example clean

install:
	bin/install.sh bin/lcov $(BIN_DIR)/lcov
	bin/install.sh bin/genhtml $(BIN_DIR)/genhtml
	bin/install.sh bin/geninfo $(BIN_DIR)/geninfo
	bin/install.sh bin/genpng $(BIN_DIR)/genpng
	bin/install.sh bin/gendesc $(BIN_DIR)/gendesc
	bin/install.sh man/lcov.1 $(MAN_DIR)/man1/lcov.1
	bin/install.sh man/genhtml.1 $(MAN_DIR)/man1/genhtml.1
	bin/install.sh man/geninfo.1 $(MAN_DIR)/man1/geninfo.1
	bin/install.sh man/genpng.1 $(MAN_DIR)/man1/genpng.1
	bin/install.sh man/gendesc.1 $(MAN_DIR)/man1/gendesc.1

uninstall:
	bin/install.sh --uninstall bin/lcov $(BIN_DIR)/lcov
	bin/install.sh --uninstall bin/genhtml $(BIN_DIR)/genhtml
	bin/install.sh --uninstall bin/geninfo $(BIN_DIR)/geninfo
	bin/install.sh --uninstall bin/genpng $(BIN_DIR)/genpng
	bin/install.sh --uninstall bin/gendesc $(BIN_DIR)/gendesc
	bin/install.sh --uninstall man/lcov.1 $(MAN_DIR)/lcov.1
	bin/install.sh --uninstall man/genhtml.1 $(MAN_DIR)/genhtml.1
	bin/install.sh --uninstall man/geninfo.1 $(MAN_DIR)/geninfo.1
	bin/install.sh --uninstall man/genpng.1 $(MAN_DIR)/genpng.1
	bin/install.sh --uninstall man/gendesc.1 $(MAN_DIR)/gendesc.1

dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
      lcov-$(VERSION)-$(RELEASE).src.rpm

lcov-$(VERSION).tar.gz: $(FILES)
	mkdir $(TMP_DIR)
	mkdir $(TMP_DIR)/lcov-$(VERSION)
	cp -r * $(TMP_DIR)/lcov-$(VERSION)
	make -C $(TMP_DIR)/lcov-$(VERSION) clean
	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(DATE) \
			     $(RELEASE)
	cd $(TMP_DIR) ; \
	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION)
	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .
	rm -rf $(TMP_DIR)

lcov-$(VERSION)-$(RELEASE).noarch.rpm: rpms
lcov-$(VERSION)-$(RELEASE).src.rpm: rpms

rpms: lcov-$(VERSION).tar.gz
	mkdir $(TMP_DIR)
	mkdir $(TMP_DIR)/BUILD
	mkdir $(TMP_DIR)/RPMS
	mkdir $(TMP_DIR)/SOURCES
	mkdir $(TMP_DIR)/SRPMS
	cp lcov-$(VERSION).tar.gz $(TMP_DIR)/SOURCES
	cd $(TMP_DIR)/BUILD ; \
	tar xfz $(TMP_DIR)/SOURCES/lcov-$(VERSION).tar.gz \
		lcov-$(VERSION)/rpm/lcov.spec
	rpmbuild --define '_topdir $(TMP_DIR)' \
		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec
	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
	rm -rf $(TMP_DIR)

## lcov 1.4

=== Makefile ===
--- 
+++ 
@@ -11,15 +11,16 @@
 #   - clean:     remove all generated files
 #
 
-VERSION := 1.3
+VERSION := 1.4
 RELEASE := 1
 DATE    := $(shell date +%Y-%m-%d)
 
+CFG_DIR := $(PREFIX)/etc
 BIN_DIR := $(PREFIX)/usr/bin
 MAN_DIR := $(PREFIX)/usr/share/man
 TMP_DIR := /tmp/lcov-tmp.$(shell echo $$$$)
 FILES   := $(wildcard bin/*) $(wildcard man/*) README CHANGES Makefile \
-	   $(wildcard rpm/*)
+	   $(wildcard rpm/*) lcovrc
 
 .PHONY: all info clean install uninstall rpms
 
@@ -44,6 +45,8 @@
 	bin/install.sh man/geninfo.1 $(MAN_DIR)/man1/geninfo.1
 	bin/install.sh man/genpng.1 $(MAN_DIR)/man1/genpng.1
 	bin/install.sh man/gendesc.1 $(MAN_DIR)/man1/gendesc.1
+	bin/install.sh man/lcovrc.5 $(MAN_DIR)/man5/lcovrc.5
+	bin/install.sh lcovrc $(CFG_DIR)/lcovrc
 
 uninstall:
 	bin/install.sh --uninstall bin/lcov $(BIN_DIR)/lcov
@@ -51,11 +54,13 @@
 	bin/install.sh --uninstall bin/geninfo $(BIN_DIR)/geninfo
 	bin/install.sh --uninstall bin/genpng $(BIN_DIR)/genpng
 	bin/install.sh --uninstall bin/gendesc $(BIN_DIR)/gendesc
-	bin/install.sh --uninstall man/lcov.1 $(MAN_DIR)/lcov.1
-	bin/install.sh --uninstall man/genhtml.1 $(MAN_DIR)/genhtml.1
-	bin/install.sh --uninstall man/geninfo.1 $(MAN_DIR)/geninfo.1
-	bin/install.sh --uninstall man/genpng.1 $(MAN_DIR)/genpng.1
-	bin/install.sh --uninstall man/gendesc.1 $(MAN_DIR)/gendesc.1
+	bin/install.sh --uninstall man/lcov.1 $(MAN_DIR)/man1/lcov.1
+	bin/install.sh --uninstall man/genhtml.1 $(MAN_DIR)/man1/genhtml.1
+	bin/install.sh --uninstall man/geninfo.1 $(MAN_DIR)/man1/geninfo.1
+	bin/install.sh --uninstall man/genpng.1 $(MAN_DIR)/man1/genpng.1
+	bin/install.sh --uninstall man/gendesc.1 $(MAN_DIR)/man1/gendesc.1
+	bin/install.sh --uninstall man/lcovrc.5 $(MAN_DIR)/man5/lcovrc.5
+	bin/install.sh --uninstall lcovrc $(CFG_DIR)/lcovrc
 
 dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
       lcov-$(VERSION)-$(RELEASE).src.rpm

=== example/Makefile ===
#
# Makefile for the LCOV example program.
#
# Make targets:
#   - example: compile the example program
#   - output:  run test cases on example program and create HTML output
#   - clean:   clean up directory
#

CC      := gcc
CFLAGS  := -Wall -I. -fprofile-arcs -ftest-coverage

LCOV    := ../bin/lcov
GENHTML := ../bin/genhtml
GENDESC := ../bin/gendesc
GENPNG  := ../bin/genpng

# Depending on the presence of the GD.pm perl module, we can use the
# special option '--frames' for genhtml
USE_GENPNG := $(shell $(GENPNG) --help >/dev/null 2>/dev/null; echo $$?)

ifeq ($(USE_GENPNG),0)
  FRAMES := --frames
else
  FRAMES :=
endif

.PHONY: clean output test_noargs test_2_to_2000 test_overflow

all: output

example: example.o iterate.o gauss.o
	$(CC) example.o iterate.o gauss.o -o example

example.o: example.c iterate.h gauss.h
	$(CC) $(CFLAGS) -c example.c -o example.o

iterate.o: methods/iterate.c iterate.h
	$(CC) $(CFLAGS) -c methods/iterate.c -o iterate.o

gauss.o: methods/gauss.c gauss.h
	$(CC) $(CFLAGS) -c methods/gauss.c -o gauss.o

output: example descriptions test_noargs test_2_to_2000 test_overflow
	@echo
	@echo '*'
	@echo '* Generating HTML output'
	@echo '*'
	@echo
	$(GENHTML) trace_noargs.info trace_args.info trace_overflow.info \
		   --output-directory output --title "Basic example" \
		   --show-details --description-file descriptions $(FRAMES)
	@echo
	@echo '*'
	@echo '* See '`pwd`/output/index.html
	@echo '*'
	@echo

descriptions: descriptions.txt
	$(GENDESC) descriptions.txt -o descriptions

all_tests: example test_noargs test_2_to_2000 test_overflow

test_noargs:
	@echo
	@echo '*'
	@echo '* Test case 1: running ./example without parameters'
	@echo '*'
	@echo
	$(LCOV) --zerocounters --directory .
	./example
	$(LCOV) --capture --directory . --output-file trace_noargs.info --test-name test_noargs

test_2_to_2000:
	@echo
	@echo '*'
	@echo '* Test case 2: running ./example 2 2000'
	@echo '*'
	@echo
	$(LCOV) --zerocounters --directory .
	./example 2 2000
	$(LCOV) --capture --directory . --output-file trace_args.info --test-name test_2_to_2000

test_overflow:
	@echo
	@echo '*'
	@echo '* Test case 3: running ./example 0 100000 (causes an overflow)'
	@echo '*'
	@echo
	$(LCOV) --zerocounters --directory .
	./example 0 100000 || true
	$(LCOV) --capture --directory . --output-file trace_overflow.info --test-name "test_overflow"

clean:
	rm -rf *.o *.bb *.bbg *.da *.info output example descriptions

## lcov 1.5

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 #   - clean:     remove all generated files
 #
 
-VERSION := 1.4
+VERSION := 1.5
 RELEASE := 1
 DATE    := $(shell date +%Y-%m-%d)

## lcov 1.6

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 #   - clean:     remove all generated files
 #
 
-VERSION := 1.5
+VERSION := 1.6
 RELEASE := 1
 DATE    := $(shell date +%Y-%m-%d)

## lcov 1.8

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Makefile for the LTP GCOV extension (LCOV)
+# Makefile for LCOV
 #
 # Make targets:
 #   - install:   install LCOV tools and man pages on the system
@@ -11,9 +11,8 @@
 #   - clean:     remove all generated files
 #
 
-VERSION := 1.6
+VERSION := 1.8
 RELEASE := 1
-DATE    := $(shell date +%Y-%m-%d)
 
 CFG_DIR := $(PREFIX)/etc
 BIN_DIR := $(PREFIX)/usr/bin
@@ -27,7 +26,10 @@
 all: info
 
 info:
-	@echo try "'make install'", "'make uninstall'" or "'make dist'"
+	@echo "Available make targets:"
+	@echo "  install   : install binaries and man pages in PREFIX (default /)"
+	@echo "  uninstall : delete binaries and man pages from PREFIX (default /)"
+	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
 
 clean:
 	rm -f lcov-*.tar.gz
@@ -35,18 +37,18 @@
 	make -C example clean
 
 install:
-	bin/install.sh bin/lcov $(BIN_DIR)/lcov
-	bin/install.sh bin/genhtml $(BIN_DIR)/genhtml
-	bin/install.sh bin/geninfo $(BIN_DIR)/geninfo
-	bin/install.sh bin/genpng $(BIN_DIR)/genpng
-	bin/install.sh bin/gendesc $(BIN_DIR)/gendesc
-	bin/install.sh man/lcov.1 $(MAN_DIR)/man1/lcov.1
-	bin/install.sh man/genhtml.1 $(MAN_DIR)/man1/genhtml.1
-	bin/install.sh man/geninfo.1 $(MAN_DIR)/man1/geninfo.1
-	bin/install.sh man/genpng.1 $(MAN_DIR)/man1/genpng.1
-	bin/install.sh man/gendesc.1 $(MAN_DIR)/man1/gendesc.1
-	bin/install.sh man/lcovrc.5 $(MAN_DIR)/man5/lcovrc.5
-	bin/install.sh lcovrc $(CFG_DIR)/lcovrc
+	bin/install.sh bin/lcov $(BIN_DIR)/lcov -m 755
+	bin/install.sh bin/genhtml $(BIN_DIR)/genhtml -m 755
+	bin/install.sh bin/geninfo $(BIN_DIR)/geninfo -m 755
+	bin/install.sh bin/genpng $(BIN_DIR)/genpng -m 755
+	bin/install.sh bin/gendesc $(BIN_DIR)/gendesc -m 755
+	bin/install.sh man/lcov.1 $(MAN_DIR)/man1/lcov.1 -m 644
+	bin/install.sh man/genhtml.1 $(MAN_DIR)/man1/genhtml.1 -m 644
+	bin/install.sh man/geninfo.1 $(MAN_DIR)/man1/geninfo.1 -m 644
+	bin/install.sh man/genpng.1 $(MAN_DIR)/man1/genpng.1 -m 644
+	bin/install.sh man/gendesc.1 $(MAN_DIR)/man1/gendesc.1 -m 644
+	bin/install.sh man/lcovrc.5 $(MAN_DIR)/man5/lcovrc.5 -m 644
+	bin/install.sh lcovrc $(CFG_DIR)/lcovrc -m 644
 
 uninstall:
 	bin/install.sh --uninstall bin/lcov $(BIN_DIR)/lcov
@@ -69,9 +71,9 @@
 	mkdir $(TMP_DIR)
 	mkdir $(TMP_DIR)/lcov-$(VERSION)
 	cp -r * $(TMP_DIR)/lcov-$(VERSION)
+	find $(TMP_DIR)/lcov-$(VERSION) -name CVS -type d | xargs rm -rf
 	make -C $(TMP_DIR)/lcov-$(VERSION) clean
-	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(DATE) \
-			     $(RELEASE)
+	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(RELEASE)
 	cd $(TMP_DIR) ; \
 	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION)
 	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .

=== debian/changelog ===
lcov (1.8-1) unstable; urgency=low

  * New upstream release. Closes: #561111.
  * Standards-Version: 3.8.4.
  * Moved to debhelper 7 format , source format 3.0
  * Added Homepage: to debian/control. 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Mar 2010 12:21:21 +0000

lcov (1.7-1) unstable; urgency=low

  * New upstream release: Closes: #478206. 
   - libtool patch no longer required.
  * Move to Standards-Version: 3.8.1; no changes required.
  * Formatted Description better for web display. Closes: #480325.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 25 Apr 2009 14:00:15 +0100

lcov (1.6-1) unstable; urgency=low

  * New upstream version. Closes: #479206, #470072.
     - remove patch 10_gcov_tool, now implemented upstream.
     - remove patch 30_compat_libtool, now implemented upstream.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Apr 2008 18:48:08 +0100

lcov (1.5-3) unstable; urgency=low

  * Move DH_COMPAT to debian/compat.
  * Move to Standards-Version: 3.7.3. No changes required.
  * debhelper needs to be in Build-Depends, not Build-Depends-Indep.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Mar 2008 14:21:22 +0000

lcov (1.5-2) unstable; urgency=low

  * Add libtool compatability patch from CVS. Closes: #431397.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 09 Sep 2007 16:13:14 +0100

lcov (1.5-1) unstable; urgency=low

  * New upstream release.
  * Move to DH_COMPAT=5. No changes required.
  * Move to Standards-Version: 3.7.2. No changes required.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Sep 2006 15:46:57 +0100

lcov (1.4-1) unstable; urgency=low

  * New upstream release 1.4. Closes: #293184.
  * Include lcov examples.
  * Add Section: devel to debian/control
  * Moved to Standards-Version: 3.6.2; no changes required.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu,  4 Aug 2005 21:16:04 +0100

lcov (1.3-4) unstable; urgency=low

  * Fix breakage for geninfo on C++ headers. Closes: #293184.
  * Allow option --gcov-tool to change which gcov we use. Closes: #293180.
  * Work with libtool'd libraries. Closes: #290476. 

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 13 Feb 2005 21:24:35 +0000

lcov (1.3-3) unstable; urgency=low

  * Depend on dbs, not cdbs: Closes: #253613.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 12 Jun 2004 19:34:00 +0100

lcov (1.3-2) unstable; urgency=low

  * Add dependency on cdbs. Closes: #253613. 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 10 Jun 2004 19:57:45 +0100

lcov (1.3-1) unstable; urgency=low

   * Initial Release.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 19 May 2004 21:57:53 +0100

=== debian/control ===
Source: lcov
Section: devel
Priority: optional
Build-Depends: debhelper (>=7.0.50~)
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Homepage: http://ltp.sourceforge.net/coverage/lcov.php
Standards-Version: 3.8.4

Package: lcov
Architecture: all
Depends: ${misc:Depends}
Section: devel
Priority: optional
Description: Summarise Code coverage information from GCOV
 LCOV is an extension of GCOV, a GNU tool which provides information about
 what parts of a program are actually executed (i.e. "covered") while running
 a particular test case. The extension consists of a set of PERL scripts
 which build on the textual GCOV output to implement the following enhanced
 functionality:
 . 	                                                                                
  - HTML based output: coverage rates are additionally indicated using bar
    graphs and specific colors.
  - Support for large projects: overview pages allow quick browsing of
    coverage data by providing three levels of detail: directory view,
    file view and source code view.

## lcov 1.9

=== debian/changelog ===
lcov (1.9-3) unstable; urgency=low

   * Apply Fedora patches by Daniel Berrange, thanks to Michael Wild:
     - gcc-compat-4.7.patch: Fix compat with gcc 4.7
     - three-arg-open.patch: Replace 2 argument open with 3 argument open
   * DH_COMPAT=8 now. 
   * Check FTBFS now fixed:  Closes: #647138.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 May 2012 13:42:56 +0100

lcov (1.9-2) unstable; urgency=low

  * Patch to change genhtml got overwritten by autogenerated debian-changes
    patch. Fixed. Closes: #5999932. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Oct 2010 00:11:27 +0100

lcov (1.9-1) unstable; urgency=low

  * New upstream release. Closes: #599388, #413834.
  * Standards-Version: 3.9.1
  * Patch from Enrico Zini for genhtml in missing source file case.
    Closes: #578571.
  * Patch from Guillem Jover for UTF-8. Closes: #590562.
  * PERL should be spelt "Perl". Closes: #589753.
  * Add Depends: on ${perl:Depends}, gcc; Recommends: libgd-gd2-perl

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 08 Oct 2010 13:52:49 +0100

lcov (1.8-2) unstable; urgency=low

  * Pass --no-recursion flag to geninfo. Patch thanks to 
    Guillem Jover. Closes: #588322. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Jul 2010 12:04:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: lcov
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>=7.0.50~)
+Build-Depends: debhelper (>=8.1.3)
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: http://ltp.sourceforge.net/coverage/lcov.php
-Standards-Version: 3.8.4
+Standards-Version: 3.9.3
 
 Package: lcov
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, ${perl:Depends}, gcc
+Recommends: libgd-gd2-perl
 Section: devel
 Priority: optional
 Description: Summarise Code coverage information from GCOV
  LCOV is an extension of GCOV, a GNU tool which provides information about
  what parts of a program are actually executed (i.e. "covered") while running
- a particular test case. The extension consists of a set of PERL scripts
+ a particular test case. The extension consists of a set of Perl scripts
  which build on the textual GCOV output to implement the following enhanced
  functionality:
  .

=== debian/rules ===
#!/usr/bin/make -f

# Debhelper 7 rules

%:
	dh $@

override_dh_auto_install:
	$(MAKE) PREFIX=`pwd`/debian/lcov install

## lcov 1.10

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 #   - clean:     remove all generated files
 #
 
-VERSION := 1.8
+VERSION := 1.10
 RELEASE := 1
 
 CFG_DIR := $(PREFIX)/etc

=== debian/changelog ===
lcov (1.10-1) unstable; urgency=low

  [Alastair McKinstry]
  * New upstream release. Closes: #699426.
  * Standards-Version: 3.9.5 
  * DH_COMPAT=9 now.
  * Add watch file.

  [Zack Weinberg]
   * Refresh debian/patches:
     - recursion.patch: Applied upstream (closes: #588322)
     - three-arg-open.patch: Applied upstream.
     - genhtml_missing_file.patch: Fixed differently upstream (closes: #578751)
     - utf8-output.patch: Fixed differently upstream (closes #590562)
     - gcc-compat-4.7.patch: Fixed differently upstream.
     - perl-nocaps.patch: Partially applied upstream.
   * New local patch (handle-equals-signs.patch) for the floods of
         geninfo: Argument "=====" isn't numeric. 
      errors that you can get when processing C++ with exception handlers.  
      Closes: #699565.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 30 Nov 2013 15:51:29 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: lcov
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>=8.1.3)
+Build-Depends: debhelper (>=9)
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: http://ltp.sourceforge.net/coverage/lcov.php
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 
 Package: lcov
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-# Debhelper 7 rules
+# Debhelper rules
 
 %:
 	dh $@

## lcov 1.11

=== debian/changelog ===
lcov (1.11-3) unstable; urgency=medium

  * Fix each() behaviour now undefined  with perl5.20. Closes: #761308.
  * Acknowledge bug fixed in previous release: Closes: #607206.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 13 Sep 2014 14:05:50 +0100

lcov (1.11-2) unstable; urgency=medium

  * Fix for fail on virtual destructors. Thanks to  Peter Oberparleiter.
    Closes: #752451.
  * Now use xz compression.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 Jun 2014 16:22:33 +0100

lcov (1.11-1) unstable; urgency=medium

  * New upstream release. Closes: #750192.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Jun 2014 08:37:11 +0100

## lcov 1.12

=== Makefile ===
--- 
+++ 
@@ -11,14 +11,15 @@
 #   - clean:     remove all generated files
 #
 
-VERSION := 1.10
-RELEASE := 1
+VERSION := $(shell bin/get_version.sh --version)
+RELEASE := $(shell bin/get_version.sh --release)
+FULL    := $(shell bin/get_version.sh --full)
 
 CFG_DIR := $(PREFIX)/etc
 BIN_DIR := $(PREFIX)/usr/bin
 MAN_DIR := $(PREFIX)/usr/share/man
-TMP_DIR := /tmp/lcov-tmp.$(shell echo $$$$)
-FILES   := $(wildcard bin/*) $(wildcard man/*) README CHANGES Makefile \
+TMP_DIR := $(shell mktemp -d)
+FILES   := $(wildcard bin/*) $(wildcard man/*) README Makefile \
 	   $(wildcard rpm/*) lcovrc
 
 .PHONY: all info clean install uninstall rpms
@@ -49,6 +50,17 @@
 	bin/install.sh man/gendesc.1 $(MAN_DIR)/man1/gendesc.1 -m 644
 	bin/install.sh man/lcovrc.5 $(MAN_DIR)/man5/lcovrc.5 -m 644
 	bin/install.sh lcovrc $(CFG_DIR)/lcovrc -m 644
+	bin/updateversion.pl $(BIN_DIR)/lcov $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(BIN_DIR)/genhtml $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(BIN_DIR)/geninfo $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(BIN_DIR)/genpng $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(BIN_DIR)/gendesc $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(MAN_DIR)/man1/lcov.1 $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(MAN_DIR)/man1/genhtml.1 $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(MAN_DIR)/man1/geninfo.1 $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(MAN_DIR)/man1/genpng.1 $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(MAN_DIR)/man1/gendesc.1 $(VERSION) $(RELEASE) $(FULL)
+	bin/updateversion.pl $(MAN_DIR)/man5/lcovrc.5 $(VERSION) $(RELEASE) $(FULL)
 
 uninstall:
 	bin/install.sh --uninstall bin/lcov $(BIN_DIR)/lcov
@@ -68,12 +80,12 @@
       lcov-$(VERSION)-$(RELEASE).src.rpm
 
 lcov-$(VERSION).tar.gz: $(FILES)
-	mkdir $(TMP_DIR)
 	mkdir $(TMP_DIR)/lcov-$(VERSION)
 	cp -r * $(TMP_DIR)/lcov-$(VERSION)
-	find $(TMP_DIR)/lcov-$(VERSION) -name CVS -type d | xargs rm -rf
+	bin/copy_dates.sh . $(TMP_DIR)/lcov-$(VERSION)
 	make -C $(TMP_DIR)/lcov-$(VERSION) clean
-	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(RELEASE)
+	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(RELEASE) $(FULL)
+	bin/get_changes.sh > $(TMP_DIR)/lcov-$(VERSION)/CHANGES
 	cd $(TMP_DIR) ; \
 	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION)
 	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .

=== debian/changelog ===
lcov (1.12-3) unstable; urgency=medium

  * Standards-Version: 3.9.8. No changes required
  * Further reproducibility: Ensure filenames are handled in LC_ALL=C order
	
 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Jul 2016 12:25:25 +0100

lcov (1.12-2) unstable; urgency=medium

  * Patch for reproducibility from Reiner Herrmann. Closes: #803412. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 30 Oct 2015 01:59:16 +0000

lcov (1.12-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 3.9.6
  * Add Vcs-Git to debian/control

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Oct 2015 17:09:43 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Build-Depends: debhelper (>=9)
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: http://ltp.sourceforge.net/coverage/lcov.php
-Standards-Version: 3.9.5
+Vcs-Git: https://github.com/linux-test-project/lcov.git
+Standards-Version: 3.9.8
 
 Package: lcov
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 # Debhelper rules
+
+LC_ALL=C
+export LC_ALL
 
 %:
 	dh $@

## lcov 1.13

=== Makefile ===
#
# Makefile for LCOV
#
# Make targets:
#   - install:   install LCOV tools and man pages on the system
#   - uninstall: remove tools and man pages from the system
#   - dist:      create files required for distribution, i.e. the lcov.tar.gz
#                and the lcov.rpm file. Just make sure to adjust the VERSION
#                and RELEASE variables below - both version and date strings
#                will be updated in all necessary files.
#   - clean:     remove all generated files
#

VERSION := $(shell bin/get_version.sh --version)
RELEASE := $(shell bin/get_version.sh --release)
FULL    := $(shell bin/get_version.sh --full)

PREFIX  := /usr/local

CFG_DIR := $(PREFIX)/etc
BIN_DIR := $(PREFIX)/bin
MAN_DIR := $(PREFIX)/share/man
TMP_DIR := $(shell mktemp -d)
FILES   := $(wildcard bin/*) $(wildcard man/*) README Makefile \
	   $(wildcard rpm/*) lcovrc

.PHONY: all info clean install uninstall rpms

all: info

info:
	@echo "Available make targets:"
	@echo "  install   : install binaries and man pages in DESTDIR (default /)"
	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
	@echo "  dist      : create packages (RPM, tarball) ready for distribution"

clean:
	rm -f lcov-*.tar.gz
	rm -f lcov-*.rpm
	make -C example clean

install:
	bin/install.sh bin/lcov $(DESTDIR)$(BIN_DIR)/lcov -m 755
	bin/install.sh bin/genhtml $(DESTDIR)$(BIN_DIR)/genhtml -m 755
	bin/install.sh bin/geninfo $(DESTDIR)$(BIN_DIR)/geninfo -m 755
	bin/install.sh bin/genpng $(DESTDIR)$(BIN_DIR)/genpng -m 755
	bin/install.sh bin/gendesc $(DESTDIR)$(BIN_DIR)/gendesc -m 755
	bin/install.sh man/lcov.1 $(DESTDIR)$(MAN_DIR)/man1/lcov.1 -m 644
	bin/install.sh man/genhtml.1 $(DESTDIR)$(MAN_DIR)/man1/genhtml.1 -m 644
	bin/install.sh man/geninfo.1 $(DESTDIR)$(MAN_DIR)/man1/geninfo.1 -m 644
	bin/install.sh man/genpng.1 $(DESTDIR)$(MAN_DIR)/man1/genpng.1 -m 644
	bin/install.sh man/gendesc.1 $(DESTDIR)$(MAN_DIR)/man1/gendesc.1 -m 644
	bin/install.sh man/lcovrc.5 $(DESTDIR)$(MAN_DIR)/man5/lcovrc.5 -m 644
	bin/install.sh lcovrc $(DESTDIR)$(CFG_DIR)/lcovrc -m 644
	bin/updateversion.pl $(DESTDIR)$(BIN_DIR)/lcov $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(BIN_DIR)/genhtml $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(BIN_DIR)/geninfo $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(BIN_DIR)/genpng $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(BIN_DIR)/gendesc $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(MAN_DIR)/man1/lcov.1 $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(MAN_DIR)/man1/genhtml.1 $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(MAN_DIR)/man1/geninfo.1 $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(MAN_DIR)/man1/genpng.1 $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(MAN_DIR)/man1/gendesc.1 $(VERSION) $(RELEASE) $(FULL)
	bin/updateversion.pl $(DESTDIR)$(MAN_DIR)/man5/lcovrc.5 $(VERSION) $(RELEASE) $(FULL)

uninstall:
	bin/install.sh --uninstall bin/lcov $(DESTDIR)$(BIN_DIR)/lcov
	bin/install.sh --uninstall bin/genhtml $(DESTDIR)$(BIN_DIR)/genhtml
	bin/install.sh --uninstall bin/geninfo $(DESTDIR)$(BIN_DIR)/geninfo
	bin/install.sh --uninstall bin/genpng $(DESTDIR)$(BIN_DIR)/genpng
	bin/install.sh --uninstall bin/gendesc $(DESTDIR)$(BIN_DIR)/gendesc
	bin/install.sh --uninstall man/lcov.1 $(DESTDIR)$(MAN_DIR)/man1/lcov.1
	bin/install.sh --uninstall man/genhtml.1 $(DESTDIR)$(MAN_DIR)/man1/genhtml.1
	bin/install.sh --uninstall man/geninfo.1 $(DESTDIR)$(MAN_DIR)/man1/geninfo.1
	bin/install.sh --uninstall man/genpng.1 $(DESTDIR)$(MAN_DIR)/man1/genpng.1
	bin/install.sh --uninstall man/gendesc.1 $(DESTDIR)$(MAN_DIR)/man1/gendesc.1
	bin/install.sh --uninstall man/lcovrc.5 $(DESTDIR)$(MAN_DIR)/man5/lcovrc.5
	bin/install.sh --uninstall lcovrc $(DESTDIR)$(CFG_DIR)/lcovrc

dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
      lcov-$(VERSION)-$(RELEASE).src.rpm

lcov-$(VERSION).tar.gz: $(FILES)
	mkdir $(TMP_DIR)/lcov-$(VERSION)
	cp -r * $(TMP_DIR)/lcov-$(VERSION)
	bin/copy_dates.sh . $(TMP_DIR)/lcov-$(VERSION)
	make -C $(TMP_DIR)/lcov-$(VERSION) clean
	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(RELEASE) $(FULL)
	bin/get_changes.sh > $(TMP_DIR)/lcov-$(VERSION)/CHANGES
	cd $(TMP_DIR) ; \
	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION)
	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .
	rm -rf $(TMP_DIR)

lcov-$(VERSION)-$(RELEASE).noarch.rpm: rpms
lcov-$(VERSION)-$(RELEASE).src.rpm: rpms

rpms: lcov-$(VERSION).tar.gz
	mkdir $(TMP_DIR)
	mkdir $(TMP_DIR)/BUILD
	mkdir $(TMP_DIR)/RPMS
	mkdir $(TMP_DIR)/SOURCES
	mkdir $(TMP_DIR)/SRPMS
	cp lcov-$(VERSION).tar.gz $(TMP_DIR)/SOURCES
	cd $(TMP_DIR)/BUILD ; \
	tar xfz $(TMP_DIR)/SOURCES/lcov-$(VERSION).tar.gz \
		lcov-$(VERSION)/rpm/lcov.spec
	rpmbuild --define '_topdir $(TMP_DIR)' \
		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec
	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
	rm -rf $(TMP_DIR)

=== debian/changelog ===
lcov (1.13-3) unstable; urgency=medium

  * More changes to use dh for bit-reproducibility

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Oct 2017 18:59:32 +0100

lcov (1.13-2) unstable; urgency=medium

  * Standards-Version: 4.1.1; no changes required
  * Use dh_install to do installation for greater reproducibility

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Oct 2017 16:38:07 +0100

lcov (1.13-1) unstable; urgency=medium

  * New upstream release. Thanks Sylvestre Ledru. Closes: #848956
  * Move to debhelper 10
  * Remove obsolet patches

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 21 Dec 2016 08:25:40 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: lcov
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>=9)
+Build-Depends: debhelper (>=10)
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: http://ltp.sourceforge.net/coverage/lcov.php
 Vcs-Git: https://github.com/linux-test-project/lcov.git
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 
 Package: lcov
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

# Debhelper rules

export DH_VERBOSE=1

LC_ALL=C
export LC_ALL

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	mv debian/lcov/usr/local/bin debian/lcov/usr/bin
	mkdir -p  debian/lcov/usr/share
	mv debian/lcov/usr/local/share/man debian/lcov/usr/share/man
	rm -rf debian/lcov/usr/local

## lcov 1.14

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,10 @@
 RELEASE := $(shell bin/get_version.sh --release)
 FULL    := $(shell bin/get_version.sh --full)
 
+# Set this variable during 'make install' to specify the Perl interpreter used in
+# installed scripts, or leave empty to keep the current interpreter.
+export LCOV_PERL_PATH := /usr/bin/perl
+
 PREFIX  := /usr/local
 
 CFG_DIR := $(PREFIX)/etc
@@ -24,7 +28,7 @@
 FILES   := $(wildcard bin/*) $(wildcard man/*) README Makefile \
 	   $(wildcard rpm/*) lcovrc
 
-.PHONY: all info clean install uninstall rpms
+.PHONY: all info clean install uninstall rpms test
 
 all: info
 
@@ -33,11 +37,13 @@
 	@echo "  install   : install binaries and man pages in DESTDIR (default /)"
 	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
 	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
+	@echo "  test      : perform self-tests"
 
 clean:
 	rm -f lcov-*.tar.gz
 	rm -f lcov-*.rpm
 	make -C example clean
+	make -C test -s clean
 
 install:
 	bin/install.sh bin/lcov $(DESTDIR)$(BIN_DIR)/lcov -m 755
@@ -111,3 +117,6 @@
 	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
 	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
 	rm -rf $(TMP_DIR)
+
+test:
+	@make -C test -s all

=== example/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 all: output
 
 example: example.o iterate.o gauss.o
-	$(CC) example.o iterate.o gauss.o -o example
+	$(CC) example.o iterate.o gauss.o -o example -lgcov
 
 example.o: example.c iterate.h gauss.h
 	$(CC) $(CFLAGS) -c example.c -o example.o
@@ -49,7 +49,8 @@
 	@echo
 	$(GENHTML) trace_noargs.info trace_args.info trace_overflow.info \
 		   --output-directory output --title "Basic example" \
-		   --show-details --description-file descriptions $(FRAMES)
+		   --show-details --description-file descriptions $(FRAMES) \
+		   --legend
 	@echo
 	@echo '*'
 	@echo '* See '`pwd`/output/index.html
@@ -69,7 +70,7 @@
 	@echo
 	$(LCOV) --zerocounters --directory .
 	./example
-	$(LCOV) --capture --directory . --output-file trace_noargs.info --test-name test_noargs
+	$(LCOV) --capture --directory . --output-file trace_noargs.info --test-name test_noargs --no-external
 
 test_2_to_2000:
 	@echo
@@ -79,7 +80,7 @@
 	@echo
 	$(LCOV) --zerocounters --directory .
 	./example 2 2000
-	$(LCOV) --capture --directory . --output-file trace_args.info --test-name test_2_to_2000
+	$(LCOV) --capture --directory . --output-file trace_args.info --test-name test_2_to_2000 --no-external
 
 test_overflow:
 	@echo
@@ -89,8 +90,9 @@
 	@echo
 	$(LCOV) --zerocounters --directory .
 	./example 0 100000 || true
-	$(LCOV) --capture --directory . --output-file trace_overflow.info --test-name "test_overflow"
+	$(LCOV) --capture --directory . --output-file trace_overflow.info --test-name "test_overflow" --no-external
 
 clean:
-	rm -rf *.o *.bb *.bbg *.da *.info output example descriptions
+	rm -rf *.o *.bb *.bbg *.da *.gcno *.gcda *.info output example \
+	descriptions

=== test/Makefile ===
include common.mak

TESTDIRS   := $(sort $(patsubst %/,%,$(dir $(wildcard */Makefile))))

help: info

info:
	echo "Available make targets:"
	echo "  test   : perform self-tests"
	echo "  clean  : remove all temporary files"
	echo ""
	echo "Available make variables:"
	echo "  SIZE   : specify size of test data (small, medium, large)"
	echo "  V      : specify level of verbosity (0, 1, 2)"

test:
	for TEST in $(TESTDIRS) ; do \
		make -C $$TEST test ; \
	done

clean:
	rm -rf *.info *.counts test.log src/
	for TEST in $(TESTDIRS) ; do \
		make -C $$TEST clean ; \
	done

.PHONY: help info test clean

=== test/genhtml_output/Makefile ===
include ../common.mak

GENHTML_TEST := ./genhtml_test

TESTS := genhtml_output_zero genhtml_output_full genhtml_output_target \
	 genhtml_output_part1 genhtml_output_part2 genhtml_output_combined

test: $(TESTS)

genhtml_output_zero:
	@test_run genhtml_output_zero $(GENHTML) $(ZEROINFO) -o out_zero/

genhtml_output_full:
	@test_run genhtml_output_full $(GENHTML) $(FULLINFO) -o out_full/

genhtml_output_target:
	@test_run genhtml_output_target $(GENHTML) $(TARGETINFO) -o out_target/

genhtml_output_part1:
	@test_run genhtml_output_part1 $(GENHTML) $(PART1INFO) -o out_part1/

genhtml_output_part2:
	@test_run genhtml_output_part2 $(GENHTML) $(PART2INFO) -o out_part2/

genhtml_output_combined: genhtml_output_target
	@test_run genhtml_output_combined $(GENHTML_TEST) $(TARGETINFO) $(PART1INFO) $(PART2INFO)

clean:
	rm -rf out_*/

.PHONY: test $(TESTS) clean

=== test/lcov_add_files/Makefile ===
include ../common.mak

ADDTEST := ./add_test

TESTS := lcov_add_zero lcov_add_zero2 lcov_add_full lcov_add_full2 \
	 lcov_add_part lcov_add_part2 lcov_add_concatenated4


test: $(TESTS)

lcov_add_zero:
	# Add single zero coverage file - output should be same as input
	test_run lcov_add_zero $(ADDTEST) 1 "$(ZEROINFO)" "$(ZEROINFO)"

lcov_add_zero2:
	# Add two zero coverage files - output should be same as input
	test_run lcov_add_zero2 $(ADDTEST) 1 "$(ZEROINFO)" "$(ZEROINFO)" "$(ZEROINFO)"

lcov_add_full:
	# Add single 100% coverage file - output should be same as input
	test_run lcov_add_full $(ADDTEST) 1 "$(FULLINFO)" "$(FULLINFO)"

lcov_add_full2:
	# Add two 100% coverage file and reduce counts to 1/2 - output should
	# be same as input
	test_run lcov_add_full2 $(ADDTEST) 0.5 "$(FULLINFO)" "$(FULLINFO)" "$(FULLINFO)"

lcov_add_part:
	# Add single coverage file with random coverage rate - output should
	# be same as input
	test_run lcov_add_part $(ADDTEST) 1 "$(PART1INFO)" "$(PART1INFO)"

lcov_add_part2:
	# Add two coverage files that were split from target file - output
	# should be same as target file
	test_run lcov_add_part2 $(ADDTEST) 1 "$(TARGETINFO)" "$(PART1INFO)" "$(PART2INFO)"

lcov_add_concatenated4:
	# Add coverage file that consists of 4 concatenation of target files 
	# and reduce counts to 1/4 - output should be the same as input
	cat $(TARGETINFO) $(TARGETINFO) $(TARGETINFO) $(TARGETINFO) >concatenated.info
	test_run lcov_add_concatenated4 $(ADDTEST) 0.25 $(TARGETINFO) concatenated.info

clean:
	rm -f *.info

.PHONY: test $(TESTS) clean

=== test/lcov_diff/Makefile ===
include ../common.mak

test:
	test_run lcov_diff_apply ./diff_test

clean:
	make -C old clean
	make -C new clean
	rm -f *.info diff

=== test/lcov_misc/Makefile ===
include ../common.mak

test:
	@test_run lcov_version lcov --version
	@test_run lcov_help lcov --help

=== test/lcov_summary/Makefile ===
include ../common.mak

CHECK := ./check_counts
TESTS := lcov_summary_zero lcov_summary_full lcov_summary_target \
	 lcov_summary_part1 lcov_summary_part2 lcov_summary_concatenated \
	 lcov_summary_concatenated2

test: $(TESTS)

lcov_summary_zero:
	# Compare output of lcov --summary with generated counts
	test_run lcov_summary_zero $(CHECK) $(ZEROCOUNTS) $(ZEROINFO)
lcov_summary_full:
	# Compare output of lcov --summary with generated counts
	test_run lcov_summary_full $(CHECK) $(FULLCOUNTS) $(FULLINFO)
lcov_summary_target:
	# Compare output of lcov --summary with generated counts
	test_run lcov_summary_target $(CHECK) $(TARGETCOUNTS) $(TARGETINFO)
lcov_summary_part1:
	# Compare output of lcov --summary with generated counts
	test_run lcov_summary_part1 $(CHECK) $(PART1COUNTS) $(PART1INFO)
lcov_summary_part2:
	# Compare output of lcov --summary with generated counts
	test_run lcov_summary_part2 $(CHECK) $(PART2COUNTS) $(PART2INFO)
lcov_summary_concatenated:
	# Compare output of lcov --summary with generated counts for a
	# concatenated coverage data file
	cat $(TARGETINFO) $(TARGETINFO) > concatenated.info
	test_run lcov_summary_concatenated $(CHECK) $(TARGETCOUNTS) concatenated.info
lcov_summary_concatenated2:
	# Compare output of lcov --summary with generated counts for a
	# concatenated coverage data file (part1+part2=target)
	cat $(PART1INFO) $(PART2INFO) > concatenated2.info
	test_run lcov_summary_concatenated2 $(CHECK) $(TARGETCOUNTS) concatenated2.info



clean:
	rm -f *.info

.PHONY: test $(TESTS) clean

=== test/lcov_diff/new/Makefile ===
prog.info:

include ../../common.mak

prog.info: prog.gcda
	$(LCOV) -c -d . -o prog.info

prog.gcda: prog
	./prog || true

prog: prog.c
	$(CC) prog.c -o prog --coverage

clean:
	rm -f prog prog.gcda prog.gcno prog.info

.PHONY: all clean

=== debian/changelog ===
lcov (1.14-2) unstable; urgency=medium

  * Add patch for gcc 9 support from  upstream. Closes: #924573
  * Ack upgrade to 1.14. Closes: #924573
  * Use debhelper-compat (=12)
  * Standards-Version: 4.4.0
  * Point the VCS to a real salsa repo. Closes: #848955

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 17 Aug 2019 09:29:20 +0100

lcov (1.14-1) unstable; urgency=medium

  * New Upstream release
  * Standards-Version: 4.3.0
  * Now use debhelper 12

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Jun 2019 13:23:54 +0100

lcov (1.13-4) unstable; urgency=medium

  * Add support for gcc8.
  * Standards-Version: 4.1.4; no changes required
  * Add VCS on salsa.debian.org

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 May 2018 09:07:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: lcov
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>=10)
+Build-Depends: debhelper-compat (= 12),
+  libjson-perl, libperlio-gzip-perl
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Homepage: http://ltp.sourceforge.net/coverage/lcov.php
-Vcs-Git: https://github.com/linux-test-project/lcov.git
-Standards-Version: 4.1.1
+Homepage: https://github.com/linux-test-project/lcov.git
+Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
+Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git
+Standards-Version: 4.4.0
 
 Package: lcov
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, gcc
+Depends: ${misc:Depends}, ${perl:Depends}, gcc,  libjson-perl, libperlio-gzip-perl
 Recommends: libgd-gd2-perl
 Section: devel
 Priority: optional

=== debian/watch ===
version=3
http://ltp.sourceforge.net/coverage/lcov.php .*/lcov-(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))

## lcov 1.15

=== Makefile ===
--- 
+++ 
@@ -37,13 +37,13 @@
 	@echo "  install   : install binaries and man pages in DESTDIR (default /)"
 	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
 	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
-	@echo "  test      : perform self-tests"
+	@echo "  check     : perform self-tests"
 
 clean:
 	rm -f lcov-*.tar.gz
 	rm -f lcov-*.rpm
 	make -C example clean
-	make -C test -s clean
+	make -C tests -s clean
 
 install:
 	bin/install.sh bin/lcov $(DESTDIR)$(BIN_DIR)/lcov -m 755
@@ -95,7 +95,8 @@
 	bin/updateversion.pl $(TMP_DIR)/lcov-$(VERSION) $(VERSION) $(RELEASE) $(FULL)
 	bin/get_changes.sh > $(TMP_DIR)/lcov-$(VERSION)/CHANGES
 	cd $(TMP_DIR) ; \
-	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION)
+	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION) \
+	    --owner root --group root
 	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .
 	rm -rf $(TMP_DIR)
 
@@ -112,11 +113,14 @@
 	cd $(TMP_DIR)/BUILD ; \
 	tar xfz $(TMP_DIR)/SOURCES/lcov-$(VERSION).tar.gz \
 		lcov-$(VERSION)/rpm/lcov.spec
-	rpmbuild --define '_topdir $(TMP_DIR)' \
+	rpmbuild --define '_topdir $(TMP_DIR)' --define '_buildhost localhost' \
+		 --undefine vendor --undefine packager \
 		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec
 	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
 	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
 	rm -rf $(TMP_DIR)
 
-test:
-	@make -C test -s all
+test: check
+
+check:
+	@make -s -C tests check

=== tests/lcov/add/Makefile ===
include ../../common.mak

TESTS := zero.sh zero2.sh full.sh full2.sh part.sh part2.sh concatenated4.sh

clean:
	rm -f *.info

=== tests/lcov/diff/Makefile ===
include ../../common.mak

TESTS := test.sh

clean:
	rm -f *.info diff
	make -C old clean
	make -C new clean

=== debian/changelog ===
lcov (1.15-1) unstable; urgency=medium

  * New upstream release. Closes: #998808
  * Standards-Version: 4.6.0
  * Use debhelper-compat 13
  * Add debian/gpb.conf file with DEP-14 branches
  * Archive moved to github; update d/watch file
  * Point Vcs-Git to debian/latest branch

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Nov 2021 12:18:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: lcov
 Section: devel
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
   libjson-perl, libperlio-gzip-perl
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: https://github.com/linux-test-project/lcov.git
 Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
-Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git
-Standards-Version: 4.4.0
+Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
+Standards-Version: 4.6.0
 
 Package: lcov
 Architecture: all

## lcov 1.16

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,7 @@
 #                and RELEASE variables below - both version and date strings
 #                will be updated in all necessary files.
 #   - clean:     remove all generated files
+#   - release:   finalize release and create git tag for specified VERSION
 #
 
 VERSION := $(shell bin/get_version.sh --version)
@@ -38,6 +39,7 @@
 	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
 	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
 	@echo "  check     : perform self-tests"
+	@echo "  release   : finalize release and create git tag for specified VERSION"
 
 clean:
 	rm -f lcov-*.tar.gz
@@ -124,3 +126,22 @@
 
 check:
 	@make -s -C tests check
+
+release:
+	@if [ "$(origin VERSION)" != "command line" ] ; then echo "Please specify new version number, e.g. VERSION=1.16" >&2 ; exit 1 ; fi
+	@if [ -n "$$(git status --porcelain 2>&1)" ] ; then echo "The repository contains uncommited changes" >&2 ; exit 1 ; fi
+	@if [ -n "$$(git tag -l v$(VERSION))" ] ; then echo "A tag for the specified version already exists (v$(VERSION))" >&2 ; exit 1 ; fi
+	@echo "Preparing release tag for version $(VERSION)"
+	git checkout master
+	bin/copy_dates.sh . .
+	for FILE in README man/* rpm/* ; do \
+		bin/updateversion.pl "$$FILE" $(VERSION) 1 $(VERSION) ; \
+	done
+	git commit -a -s -m "lcov: Finalize release $(VERSION)"
+	git tag v$(VERSION) -m "LCOV version $(VERSION)"
+	@echo "**********************************************"
+	@echo "Release tag v$(VERSION) successfully created"
+	@echo "Next steps:"
+	@echo " - Review resulting commit and tag"
+	@echo " - Publish with: git push origin master v$(VERSION)"
+	@echo "**********************************************"

=== tests/Makefile ===
include common.mak

TESTS := genhtml/ lcov/

clean:
	rm -rf *.info *.counts test.log src/

=== tests/lcov/Makefile ===
include ../common.mak

TESTS := add/ diff/ misc/ summary/

=== tests/lcov/summary/Makefile ===
include ../../common.mak

TESTS := zero.sh full.sh target.sh part1.sh part2.sh concatenated.sh \
	 concatenated2.sh

clean:
	rm -f *.info *.log

=== tests/lcov/diff/old/Makefile ===
prog.info:

include ../../../common.mak

prog.info: prog.gcda
	$(LCOV) -c -d . -o prog.info

prog.gcda: prog
	./prog || true

prog: prog.c
	$(CC) prog.c -o prog --coverage

clean:
	rm -f prog prog.gcda prog.gcno prog.info

.PHONY: all clean

=== debian/changelog ===
lcov (1.16-1) unstable; urgency=medium

  * New upstream release
    - rebase patches
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 06 Jun 2022 09:19:45 +0100

lcov (1.15-2) unstable; urgency=medium

  * version.patch: version incorrectly reported. Closes: #1011531
  * Close fixed bug; repository now populated. Closes: #990915
  * Patch from Vagrant Cascadian on reproduciblity. Closes: #990914

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 25 May 2022 14:12:59 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Homepage: https://github.com/linux-test-project/lcov.git
 Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
-Standards-Version: 4.6.0
+Standards-Version: 4.6.
 
 Package: lcov
 Architecture: all
